import http from './api.helper.js'
import {
	Base64
} from 'js-base64'
// 这里的vm，就是我们在vue文件里面的this，所以我们能在这里获取vuex的变量，比如存放在里面的token
// 同时，我们也可以在此使用getApp().globalData，如果你把token放在getApp().globalData的话，也是可以使用的
const install = (Vue, vm) => {
	http.setConfig({
		baseUrl: '',
		// 如果将此值设置为true，拦截回调中将会返回服务端返回的所有数据response，而不是response.data
		// 设置为true后，就需要在this.$u.http.interceptor.response进行多一次的判断，请打印查看具体值
		// originalData: true, 
		// 设置自定义头部Content-Type
		header: {
			"Content-Type": "application/json; charset=utf-8",
		}
	});
	// 请求拦截，配置Token等参数
	http.interceptor.request = (config) => {
		// config.header['Authorization'] = `Basic ${Base64.encode('wangpc:LZY888@@')}`;
		if (config.url.indexOf('crm-app/login') === -1 && vm.$store
			.state.vuex_token) {
			config.header['X-Auth-Token'] = vm.$store.state
				.vuex_token;
		}


		if (config.header['Content-Type'] && config.header['Content-Type'].indexOf('x-www-form-urlencoded') ===
			-1) {
			config.header['Content-Type'] = "application/json; charset=utf-8"
		}


		// if (config.url.indexOf('crm-app') !== -1) {
		// 	config.baseUrl = 'http://10.0.135.139'
		// } else {
		// 	config.baseUrl = 'http://10.0.134.45:8000'
		// }

		// if (config.url.indexOf('crm-app/login') !== -1 && !vm.$store.state.vuex_token) {
		// 	uni.showToast({
		// 		title: '登录已失效',
		// 		duration: 2000,
		// 		icon: 'none'
		// 	});
		// 	uni.navigateTo({
		// 		url: "/pages/login/login"
		// 	})
		// }
		// 方式一，存放在vuex的token，假设使用了uView封装的vuex方式，见：https://uviewui.com/components/globalVariable.html
		// config.header.token = vm.token;

		// 方式二，如果没有使用uView封装的vuex方法，那么需要使用$store.state获取
		// config.header.token = vm.$store.state.token;

		// 方式三，如果token放在了globalData，通过getApp().globalData获取
		// config.header.token = getApp().globalData.username;

		// 方式四，如果token放在了Storage本地存储中，拦截是每次请求都执行的，所以哪怕您重新登录修改了Storage，下一次的请求将会是最新值
		// const token = uni.getStorageSync('token');
		// config.header.token = token;
		// console.log('http.interceptor.request', config)
		return config;
	}
	// 响应拦截，判断状态码是否通过
	http.interceptor.response = (res) => {
		// 如果把originalData设置为了true，这里得到将会是服务器返回的所有的原始数据
		// 判断可能变成了res.statueCode，或者res.data.code之类的，请打印查看结果
		// console.log('http.interceptor---response-----', res)
		if (res.MSGTYPE === 'S' || res.msgtype === 'S' || res.status === 1 || res.status === 0 || res.result === 'S' || res
			.Status ===
			'Success') {
			// 如果把originalData设置为了true，这里return回什么，this.$u.post的then回调中就会得到什么
			return res;
		} else {
			if(!res.status&&!res.msgtype&&!res.MSGTYPE){
				return res;
			}
			uni.showToast({
				title: res.MESSAGE || res.msg || res.message || res.ErrMsg,
				duration: 4000,
				icon: 'none'
			});
			return false
		};
	}
}

export default {
	install
}
